# coding: utf-8


"""
IGNORE:
    Nutanix Data Policies APIs

    Manage Policies for Disaster Recovery and Storage.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
import ntnx_datapolicies_py_client.models
from ntnx_datapolicies_py_client.models.OneOfdatapolicies.v4.config.ReplicationLocationreplication_sub_location import ReplicationLocationreplication_sub_location  # noqa: F401,E501

class ReplicationLocation(object):

    """Indicates all the locations participating in the protection policy. You can specify up to 3 replication locations.

    :param label: (:attr:`label`) This is a unique user defined label of the replication location. It is used to identify the location in the replication configurations.
    :type label: required
     max=1000 chars
    
    :param domain_manager_ext_id: (:attr:`domain_manager_ext_id`) External identifier of the domain manager.
    :type domain_manager_ext_id: required
    
    
    :param replication_sub_location: (:attr:`replication_sub_location`) Specifies the replication sublocations where recovery points can be created or replicated.
    :type replication_sub_location: 
    
    
    :param is_primary: (:attr:`is_primary`) One of the locations must be specified as the primary location. All the other locations must be connected to the primary location.
    :type is_primary: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'label': 'str',
        'domain_manager_ext_id': 'str',
        'replication_sub_location': 'OneOfdatapolicies.v4.config.ReplicationLocationreplication_sub_location',
        'is_primary': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'label': 'label',
        'domain_manager_ext_id': 'domainManagerExtId',
        'replication_sub_location': 'replicationSubLocation',
        'is_primary': 'isPrimary',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, label=None, domain_manager_ext_id=None, replication_sub_location=None, is_primary=None, *args, **kwargs):  # noqa: E501
        self.__label = None
        self.__domain_manager_ext_id = None
        self.__replication_sub_location = None
        self.__is_primary = None
        self.discriminator = None
        self.__label = label
        self.__domain_manager_ext_id = domain_manager_ext_id
        if replication_sub_location is not None:
            self.__replication_sub_location = replication_sub_location
        if is_primary is not None:
            self.__is_primary = is_primary
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'datapolicies.v4.config.ReplicationLocation'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def label(self):
        """
        This is a unique user defined label of the replication location. It is used to identify the location in the replication configurations.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__label

    @label.setter
    def label(self, label):
        if label is None:
            raise ValueError("Invalid value for `label`, must not be `None`")  # noqa: E501
        if label is not None and len(label) > 1000:
            raise ValueError("Invalid value for `label`, length must be less than or equal to `1000`")  # noqa: E501

        self.__label = label

    @property
    def domain_manager_ext_id(self):
        """
        External identifier of the domain manager.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__domain_manager_ext_id

    @domain_manager_ext_id.setter
    def domain_manager_ext_id(self, domain_manager_ext_id):
        if domain_manager_ext_id is None:
            raise ValueError("Invalid value for `domain_manager_ext_id`, must not be `None`")  # noqa: E501
        if domain_manager_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', domain_manager_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `domain_manager_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__domain_manager_ext_id = domain_manager_ext_id

    @property
    def replication_sub_location(self):
        """
        Specifies the replication sublocations where recovery points can be created or replicated.

        :type:
                :class:`~ntnx_datapolicies_py_client.models.datapolicies.v4.config.NutanixCluster`
        """  # noqa: E501
        return self.__replication_sub_location

    @replication_sub_location.setter
    def replication_sub_location(self, replication_sub_location):

        self.__replication_sub_location = replication_sub_location

    @property
    def is_primary(self):
        """
        One of the locations must be specified as the primary location. All the other locations must be connected to the primary location.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_primary

    @is_primary.setter
    def is_primary(self, is_primary):

        self.__is_primary = is_primary

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_datapolicies_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ReplicationLocation, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReplicationLocation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

